
%rename (sim_AddSpiceMeasure_sub) sim_AddSpiceMeasure;
%rename (sim_AddSpiceMeasureDelay_sub) sim_AddSpiceMeasureDelay;
%rename (sim_AddSpiceMeasureSlope_sub) sim_AddSpiceMeasureSlope;

extern SimulationContext *sim_CreateContext          (Netlist *netlist);
extern void               sim_RunSimulation          (SimulationContext *sc, char *sim_call);
extern void               sim_AddInitLevel           (SimulationContext *sc, char *node, int level);
extern void               sim_AddWaveForm            (SimulationContext *sc, char *node, TimeValue trise, TimeValue tfall, TimeValue periode, char *pattern);
void                      sim_AddSpiceMeasureSlope   (SimulationContext *sc, char *slope, char *sig, char *transition, char delay_type);
void                      sim_AddSpiceMeasureDelay   (SimulationContext *sc, char *delay, char *sig1, char *sig2, char *transition, char delay_type);
double                    sim_GetSpiceMeasureSlope   (SimulationContext *model, char *label);
double                    sim_GetSpiceMeasureDelay   (SimulationContext *model, char *label);
void                      sim_FreeContext            (SimulationContext *model);
void                      sim_DefineInclude          (SimulationContext *sc, char *filename);
Netlist                  *sim_GetContextNetlist      (SimulationContext *sc);
double sim_ReadMeasure(char *filename, char *label);
void sim_ResetMeasures(SimulationContext *model);

// from gns

extern void sim_SetSimulatorType (SimulationContext *sc, char *type);
extern SimulationContext *sim_CreateContext (Netlist *netlist);
SimulationContext *sim_CreateNetlistContext();
Netlist *sim_GetContextNetlist(SimulationContext *sc);
void sim_FreeContext (SimulationContext *model);
extern void   sim_SetDelayVTH    (SimulationContext *sc, VoltageValue vth); 
extern void   sim_SetSlopeVTH   (SimulationContext *sc, VoltageValue vth_low, VoltageValue vth_high);
extern void   sim_SetSimulationSlope       (SimulationContext *sc, TimeValue slope);
extern void   sim_SetSimulationTime (SimulationContext *sc, TimeValue time);
extern void   sim_SetSimulationStep (SimulationContext *sc, TimeValue step);
extern void   sim_SetSimulationSupply (SimulationContext *sc, VoltageValue v_max);
void sim_SetInputSwing (SimulationContext *sc, VoltageValue v_vss, VoltageValue v_max);
void sim_SetOutputSwing (SimulationContext *sc, VoltageValue v_vss, VoltageValue v_max);
extern double sim_GetSimulationSupply();
extern void   sim_SetSimulationTemp (SimulationContext *sc, double temp);
extern void   sim_AddSimulationTechnoFile (SimulationContext *sc, char *tech_file);
extern void   sim_SetSimulationCall (SimulationContext *sc, char *sim_call);
extern void   sim_NoiseSetAnalyseType (SimulationContext *sc, char noise_type);
extern void   sim_SetSimulationOutputFile (SimulationContext *sc, char *output_file);
extern void   sim_AddStuckLevel (SimulationContext *sc, char *node, int level);
extern void   sim_AddStuckLevelVector (SimulationContext *sc, char *node, char *level);
extern void   sim_AddStuckVoltage     (SimulationContext *sc, char *node, VoltageValue voltage);
extern void   sim_AddSlope (SimulationContext *sc, char *node, TimeValue start_time, TimeValue transition_time, char sense);
extern void   sim_AddSignalSlope (SimulationContext *sc, char *node, TimeValue start_time, TimeValue transition_time, char sense);
PwlFunction *sim_builtin_tanh ();
PwlFunction *sim_builtin_ramp ();
void sim_SetExternalCapacitance(SimulationContext *sc, char *node, CapaValue value);
extern void   sim_AddWaveForm (SimulationContext *sc, char *node, TimeValue trise, TimeValue tfall, TimeValue periode, char *pattern);
extern void   sim_AddInitLevel        (SimulationContext *sc, char *node, int level);
extern void   sim_AddInitVoltage     (SimulationContext *sc, char *node, VoltageValue voltage);
void sim_AddOutLoad (SimulationContext *sc, char *node, CapaValue load);
//extern void   sim_AddMeasure (SimulationContext *sc, char *node);
extern void   sim_AddMeasureCurrent   (SimulationContext *sc, char *node);
extern void   sim_RunSimulation (SimulationContext *sc, char *sim_call);
//extern double sim_ExtractMinSlope (SimulationContext *sc, char *node);
//extern double sim_ExtractMaxSlope (SimulationContext *sc, char *node);
//extern double sim_ExtractMinDelay (SimulationContext *sc, char *node_a,char *node_b);
//extern double sim_ExtractMaxDelay (SimulationContext *sc, char *node_a,char *node_b);
//extern Timing *sim_ExtractAllTimings (SimulationContext *sc, char *node_a,char *node_b);
//extern double sim_ExtractMinTransitionDelay (SimulationContext *sc, char *node_a,char *node_b,char *transition);
//extern double sim_ExtractMaxTransitionDelay (SimulationContext *sc, char *node_a,char *node_b,char *transition);
//extern double sim_ExtractMinTransitionSlope (SimulationContext *sc, char *node,char *transition);
//extern double sim_ExtractMaxTransitionSlope (SimulationContext *sc, char *node,char *transition);
extern double sim_ComputeSetup (SimulationContext *sc, char *data,TimeValue tstart_d,TimeValue tslope_d, char sense_d, char *cmd,TimeValue t_start_min_c, TimeValue t_start_max_c, TimeValue tslope_c,char sense_c, char *mem, int data_val);
extern double sim_ComputeHold (SimulationContext *sc, char *data, TimeValue tstart_d,TimeValue tslope_d, char sense_d, char *cmd,TimeValue t_start_min_c, TimeValue t_start_max_c, TimeValue tslope_c,char sense_c, char *mem, int data_val);
//extern double sim_ComputeAccess (SimulationContext *sc, char *dout, int dout_val,char *cmd, TimeValue tstart_c, TimeValue tslope_c, char sens_c, char *mem, int mem_val, double *out_slope);
extern double elp_GetCapaFromConnector (SimulationContext *sc, Connector *locon);
//extern List   *sim_ComputeDelay (SimulationContext *sc, char *input, char sens, List *list_output);
//extern double  sim_ComputeMaxDelayTransition (SimulationContext *sc, char *input, double input_start, double input_slope,char *output, char *transition);
//extern double  sim_ComputeMinDelayTransition (SimulationContext *sc, char *input, double input_start, double input_slope,char *output, char *transition);
//extern Timing *sim_GetTimingFromList   (List *list);
//extern Timing *sim_GetTimingNext       (Timing *timing);
//extern Timing *sim_GetTiming           (char *root,char *node);
//extern Timing *sim_GetTimingByEvent    (char *root,char *node,char *event);
//extern double  sim_GetTimingDelay      (Timing *timing);
//extern double  sim_GetTimingMinDelay   (Timing *timing);
//extern double  sim_GetTimingMaxDelay   (Timing *timing);
//extern double  sim_GetTimingSlope      (Timing *timing);
//extern double  sim_GetTimingMinSlope   (Timing *timing);
//extern double  sim_GetTimingMaxSlope   (Timing *timing);
//extern char   *sim_GetTimingRoot       (Timing *timing);
//extern char   *sim_GetTimingNode       (Timing *timing);
//extern char   *sim_GetTimingRootInNetlist  (Timing *timing);
//extern char   *sim_GetTimingNodeInNetlist  (Timing *timing);
//extern char    sim_GetTimingRootEvent  (Timing *timing);
//extern char    sim_GetTimingNodeEvent  (Timing *timing);
//extern void   sim_NoiseExtract  (SimulationContext *sc, char *node, double vthnoise, double tinit, double tfinal);
//extern double sim_NoiseGetVth   (SimulationContext *sc, char *name);
//extern List  *sim_NoiseGetPeakList (SimulationContext *sc, char *name);
//extern List  *sim_NoiseGetMomentList (SimulationContext *sc, char *name);
//extern double sim_NoiseGetMoment (SimulationContext *sc, List *noise_tclist);
//extern double sim_NoiseGetPeakValue (SimulationContext *sc, char *name,List *noise_peaklist);
//extern double sim_NoiseGetPeakMoment (SimulationContext *sc, List *noise_peaklist);
//extern double sim_NoiseExtractMaxPeakValue (SimulationContext *sc, char *name);
//extern double sim_NoiseExtractMinPeakValue (SimulationContext *sc, char *name);
//extern double sim_NoiseExtractMaxPeakMoment (SimulationContext *sc, char *name);
//extern double sim_NoiseExtractMinPeakMoment (SimulationContext *sc, char *name);
//extern double sim_NoiseGetMomentBeforePeak (SimulationContext *sc, char *name,List *peak);
//extern double sim_NoiseGetMomentAfterPeak (SimulationContext *sc, char *name,List *peak);
//extern double sim_NoiseGetPeakDuration (SimulationContext *sc, char *name,List *peak);
//extern double sim_NoiseExtractMomentBeforeMaxPeak (SimulationContext *sc, char *name);
//extern double sim_NoiseExtractMomentBeforeMinPeak (SimulationContext *sc, char *name);
//extern double sim_NoiseExtractMomentAfterMaxPeak (SimulationContext *sc, char *name);
//extern double sim_NoiseExtractMomentAfterMinPeak (SimulationContext *sc, char *name);
//extern double sim_NoiseExtractMaxPeakDuration (SimulationContext *sc, char *name);
//extern double sim_NoiseExtractMinPeakDuration (SimulationContext *sc, char *name);
//extern void sim_DriveLut (SimulationContext *sc, char *lcin, char *lcout, char *transition, List *slew_range, List *load_range);
//extern void sim_DriveNodeState (SimulationContext *sc, char *filename,char *node_ref,char *node_state2drive,char type);
//extern double sim_ExtractCommutInstant (SimulationContext *sc, char *node,double voltage);
extern void sim_DriveTransistorAsInstance (SimulationContext *sc, char mode);
extern Netlist *sim_GetNetlist (char *name);
//extern SimulationContext *sim_SaveContext (SimulationContext *sc, char *label);
//extern SimulationContext *sim_GetSavedContext(SimulationContext *src, char *label);
//void sim_AddAlias(SimulationContext *sc, char *source, char *destination);
void SET_CONTEXT(SimulationContext *sc);
SimulationContext *GET_CONTEXT();
void sim_AddSpiceMeasure(SimulationContext *sc, char *delay, char *slope, char *sig1, char *sig2, char *transition, char delay_type);
//void sim_AddSpiceMeasureSlope(SimulationContext *sc, char *slope, char *sig, char *transition, char delay_type);
//void sim_AddSpiceMeasureDelay(SimulationContext *sc, char *delay, char *sig1, char *sig2, char *transition, char delay_type);
double sim_ReadMeasure(char *filename, char *label);
//int sim_GetSpiceMeasure(SimulationContext *sc, char *label, double *value);
double sim_GetSpiceMeasureSlope(SimulationContext *model, char *label);
double sim_GetSpiceMeasureDelay(SimulationContext *model, char *label);
void sim_SpiceMeasure(SimulationContext *model, char *delay, double *valued, char *slope, double *values, char *sig1, char *sig2, char *transition, char delay_type);
//void sim_SpiceMeasureDelay(SimulationContext *model, char *delay, double *value, char *sig1, char *sig2, char *transition, char delay_type);
//void sim_SpiceMeasureSlope(SimulationContext *model, char *slope, double *value, char *sig, char *transition, char delay_type);
void sim_DumpDelayDetail(SimulationContext *model, char *name1, char *name2, char *transition, FILE *f);
void sim_RenameModel(SimulationContext *sc, char *name);
double sim_SpreadRC(SimulationContext *sc, char *input, char *output, char *dir, TimeValue input_delay, TimeValue delta_delay);
void sim_DefineInclude(SimulationContext *sc, char *filename);

void gsp_AddCorrelation(char *name0, char *name1, int tog);
