/****************************************************************************/
/*                                                                          */
/*                      Chaine de verification                              */
/*                                                                          */
/*    Produit : AVT Version 1                                               */
/*    Fichier : avt_util.h                                                  */
/*                                                                          */
/*    (c) copyright 1998-1999 AVERTEC                                       */
/*    Tous droits reserves                                                  */
/*    Support : e-mail Karim.Dioury@asim.lip6.fr                            */
/*                                                                          */
/*    Auteur(s) : DIOURY Karim                                              */
/*                                                                          */
/****************************************************************************/

#include "avt_headers.h"

#define WINDOW_SIZE 81
#define LINES 15
#define ASCENT 13

extern char *AVERTEC_VERSION ;
extern char *AVT_FULLVERSION ;

static char screen[LINES][WINDOW_SIZE];

/* Font definition for the banner

   Rights on font material :

   Donated by H. Kagotani <kagotani@cs.titech.ac.jp>; public domain
   font from Japan
   -Misc-Fixed-Medium-R-Normal--14-130-75-75-C-140-JISX0208.1983-0
   "Public domain font.  Share and enjoy."

	This font has been extracted from X11r5 bdf file by myself, to
   be used for the standard Aliiance CAD system banners. */

static const char *Unknown_Bold_Normal_14[][62] = {
{
"         ",
"   @@@   ",
" @@   @@ ",
"@@     @@",
"@@     @@",
"@@     @@",
"@@     @@",
"@@     @@",
"@@     @@",
"@@     @@",
" @@   @@ ",
"   @@@   ",
"         ",
"         ",
"         "},
/* lines 15 */
/* 2331 */
{
"      ",
"   @  ",
"  @@  ",
"@@@@  ",
"  @@  ",
"  @@  ",
"  @@  ",
"  @@  ",
"  @@  ",
"  @@  ",
"  @@  ",
"@@@@@@",
"      ",
"      ",
"      "},
/* lines 15 */
/* 2332 */
{
"        ",
"  @@@@  ",
" @   @@ ",
"@@    @@",
"@@@   @@",
" @   @@ ",
"     @  ",
"    @   ",
"   @    ",
"  @    @",
" @@@@@@ ",
"@@@@@@@ ",
"        ",
"        ",
"        "},
/* lines 15 */
/* 2333 */
{
"        ",
"  @@@@  ",
" @   @@ ",
"@@    @@",
"@@    @@",
"     @@ ",
"   @@@  ",
"      @ ",
"@@    @@",
"@@    @@",
" @   @@ ",
"  @@@@  ",
"        ",
"        ",
"        "},
/* lines 15 */
/* 2334 */
{
"         ",
"     @@  ",
"    @@@  ",
"   @ @@  ",
"   @ @@  ",
"  @  @@  ",
" @   @@  ",
"@@   @@  ",
"@@@@@@@@@",
"     @@  ",
"     @@  ",
"    @@@@ ",
"         ",
"         ",
"         "},
/* lines 15 */
/* 2335 */
{
"        ",
" @@@@@@@",
" @@@@@@ ",
" @      ",
" @      ",
" @@@@@  ",
"     @@ ",
"      @@",
"      @@",
"@@    @@",
"@@   @@ ",
" @@@@   ",
"        ",
"        ",
"        "},
/* lines 15 */
/* 2336 */
{
"         ",
"   @@@@  ",
"  @   @@ ",
" @@   @@ ",
" @       ",
"@@ @@@@  ",
"@@@   @@ ",
"@@     @@",
"@@     @@",
"@@     @@",
" @@   @@ ",
"   @@@   ",
"         ",
"         ",
"         "},
/* lines 15 */
/* 2337 */
{
"         ",
" @@@@@@@@",
" @@@@@@@ ",
"@     @  ",
"     @   ",
"     @   ",
"    @    ",
"    @    ",
"   @@    ",
"   @@    ",
"   @@    ",
"   @@    ",
"         ",
"         ",
"         "},
/* lines 15 */
/* 2338 */
{
"        ",
"  @@@@  ",
" @    @ ",
"@@    @@",
"@@@   @@",
" @@@ @@ ",
"  @@@@  ",
" @@ @@@ ",
"@@   @@@",
"@@    @@",
" @    @ ",
"  @@@@  ",
"        ",
"        ",
"        "},
/* lines 15 */
/* 2339 */
{
"        ",
"   @@   ",
" @@  @@ ",
"@@    @@",
"@@    @@",
"@@    @@",
" @@  @@@",
"  @@@ @@",
"      @@",
"@@    @ ",
"@@   @  ",
" @@@@   ",
"        ",
"        ",
"        "},
/* lines 15 */
/* 2341 */
{
"            ",
"      @     ",
"      @     ",
"     @@@    ",
"     @@@    ",
"    @  @@   ",
"    @  @@   ",
"   @    @@  ",
"   @@@@@@@  ",
"  @      @@ ",
"  @      @@ ",
"@@@@    @@@@",
"            ",
"            ",
"            "},
/* lines 15 */
/* 2342 */
{
"           ",
"@@@@@@@    ",
"  @@   @@  ",
"  @@    @@ ",
"  @@    @@ ",
"  @@   @@  ",
"  @@@@@@   ",
"  @@    @@ ",
"  @@     @@",
"  @@     @@",
"  @@    @@ ",
"@@@@@@@@   ",
"           ",
"           ",
"           "},
/* lines 15 */
/* 2343 */
{
"          ",
"    @@@@ @",
"  @@    @@",
" @@      @",
"@@       @",
"@@        ",
"@@        ",
"@@        ",
"@@        ",
" @@      @",
"  @@    @@",
"    @@@@  ",
"          ",
"          ",
"          "},
/* lines 15 */
/* 2344 */
{
"           ",
"@@@@@@@    ",
"  @@   @@  ",
"  @@    @@ ",
"  @@     @@",
"  @@     @@",
"  @@     @@",
"  @@     @@",
"  @@     @@",
"  @@    @@ ",
"  @@   @@  ",
"@@@@@@@    ",
"           ",
"           ",
"           "},
/* lines 15 */
/* 2345 */
{
"           ",
"@@@@@@@@@  ",
"  @@    @  ",
"  @@     @ ",
"  @@       ",
"  @@   @   ",
"  @@@@@@   ",
"  @@   @   ",
"  @@       ",
"  @@      @",
"  @@     @ ",
"@@@@@@@@@@ ",
"           ",
"           ",
"           "},
/* lines 15 */
/* 2346 */
{
"          ",
"@@@@@@@@@ ",
"  @@    @ ",
"  @@     @",
"  @@      ",
"  @@   @  ",
"  @@@@@@  ",
"  @@   @  ",
"  @@      ",
"  @@      ",
"  @@      ",
"@@@@@@    ",
"          ",
"          ",
"          "},
/* lines 15 */
/* 2347 */
{
"            ",
"    @@@@ @  ",
"  @@    @@  ",
" @@      @  ",
"@@          ",
"@@          ",
"@@     @@@@@",
"@@     @ @@ ",
"@@    @  @@ ",
" @@      @@ ",
"  @@    @@  ",
"    @@@@    ",
"            ",
"            ",
"            "},
/* lines 15 */
/* 2348 */
{
"           ",
"@@@@   @@@@",
" @@     @@ ",
" @@     @@ ",
" @@     @@ ",
" @@     @@ ",
" @@@@@@@@@ ",
" @@     @@ ",
" @@     @@ ",
" @@     @@ ",
" @@     @@ ",
"@@@@   @@@@",
"           ",
"           ",
"           "},
/* lines 15 */
/* 2349 */
{
"      ",
"@@@@@@",
"  @@  ",
"  @@  ",
"  @@  ",
"  @@  ",
"  @@  ",
"  @@  ",
"  @@  ",
"  @@  ",
"  @@  ",
"@@@@@@",
"      ",
"      ",
"      "},
/* lines 15 */
/* 234a */
{
"           ",
"     @@@@@@",
"       @@  ",
"       @@  ",
"       @@  ",
"       @@  ",
"       @@  ",
" @     @@  ",
"@@@    @@  ",
"@@     @@  ",
" @@   @@   ",
"   @@@     ",
"           ",
"           ",
"           "},
/* lines 15 */
/* 234b */
{
"           ",
"@@@@   @@@@",
" @@     @  ",
" @@    @   ",
" @@   @    ",
" @@  @@    ",
" @@ @ @@   ",
" @@@  @@   ",
" @@    @@  ",
" @@    @@  ",
" @@     @@ ",
"@@@@   @@@@",
"           ",
"           ",
"           "},
/* lines 15 */
/* 234c */
{
"           ",
"@@@@@@     ",
"  @@       ",
"  @@       ",
"  @@       ",
"  @@       ",
"  @@       ",
"  @@       ",
"  @@       ",
"  @@      @",
"  @@     @ ",
"@@@@@@@@@@ ",
"           ",
"           ",
"           "},
/* lines 15 */
/* 234d */
{
"           ",
"@@@     @@@",
" @@     @@ ",
" @@@   @@@ ",
" @@@   @@@ ",
" @ @@ @ @@ ",
" @ @@ @ @@ ",
" @ @@@  @@ ",
" @  @@  @@ ",
" @  @   @@ ",
" @      @@ ",
"@@@    @@@@",
"           ",
"           ",
"           "},
/* lines 15 */
/* 234e */
{
"          ",
"@@@    @@@",
" @@     @ ",
" @@@    @ ",
" @ @@   @ ",
" @ @@   @ ",
" @  @@  @ ",
" @   @@ @ ",
" @   @@ @ ",
" @    @@@ ",
" @     @@ ",
"@@@    @@ ",
"          ",
"          ",
"          "},
/* lines 15 */
/* 234f */
{
"           ",
"    @@@    ",
"  @@   @@  ",
" @@     @@ ",
"@@       @@",
"@@       @@",
"@@       @@",
"@@       @@",
"@@       @@",
" @@     @@ ",
"  @@   @@  ",
"    @@@    ",
"           ",
"           ",
"           "},
/* lines 15 */
/* 2350 */
{
"          ",
"@@@@@@@   ",
"  @@   @@ ",
"  @@    @@",
"  @@    @@",
"  @@   @@ ",
"  @@@@@   ",
"  @@      ",
"  @@      ",
"  @@      ",
"  @@      ",
"@@@@@@    ",
"          ",
"          ",
"          "},
/* lines 15 */
/* 2351 */
{
"           ",
"    @@@    ",
"  @@   @@  ",
" @@     @@ ",
"@@       @@",
"@@       @@",
"@@       @@",
"@@       @@",
"@@  @@   @@",
" @@@  @ @@ ",
"  @@   @@  ",
"    @@@@@  ",
"         @@",
"           ",
"           "},
/* lines 15 */
/* 2352 */
{
"           ",
"@@@@@@@    ",
"  @@   @@  ",
"  @@    @@ ",
"  @@    @@ ",
"  @@   @@  ",
"  @@@@@    ",
"  @@  @@   ",
"  @@   @@  ",
"  @@   @@  ",
"  @@    @@ ",
"@@@@@   @@@",
"           ",
"           ",
"           "},
/* lines 15 */
/* 2353 */
{
"         ",
"  @@@@ @ ",
" @    @@ ",
"@@     @ ",
"@@@      ",
" @@@@    ",
"   @@@@  ",
"     @@@ ",
"@      @@",
"@@     @@",
"@@@    @ ",
"@  @@@@  ",
"         ",
"         ",
"         "},
/* lines 15 */
/* 2354 */
{
"            ",
" @@@@@@@@@@ ",
" @   @@   @ ",
"@    @@    @",
"     @@     ",
"     @@     ",
"     @@     ",
"     @@     ",
"     @@     ",
"     @@     ",
"     @@     ",
"   @@@@@@   ",
"            ",
"            ",
"            "},
/* lines 15 */
/* 2355 */
{
"           ",
"@@@@    @@@",
" @@      @ ",
" @@      @ ",
" @@      @ ",
" @@      @ ",
" @@      @ ",
" @@      @ ",
" @@      @ ",
" @@      @ ",
"  @@    @  ",
"    @@@@   ",
"           ",
"           ",
"           "},
/* lines 15 */
/* 2356 */
{
"           ",
"@@@@    @@@",
" @@      @ ",
" @@      @ ",
"  @@    @  ",
"  @@    @  ",
"   @@  @   ",
"   @@  @   ",
"    @@@    ",
"    @@@    ",
"     @     ",
"     @     ",
"           ",
"           ",
"           "},
/* lines 15 */
/* 2357 */
{
"           ",
"@@@ @@@ @@@",
" @@  @@  @ ",
" @@  @@  @ ",
" @@  @@  @ ",
"  @@ @@@ @ ",
"  @@@ @@@  ",
"  @@@ @@@  ",
"   @@  @@  ",
"   @@  @@  ",
"   @@  @@  ",
"   @@  @@  ",
"           ",
"           ",
"           "},
/* lines 15 */
/* 2358 */
{
"           ",
"@@@@   @@@@",
" @@     @  ",
"  @@   @   ",
"   @@ @    ",
"    @@     ",
"    @@     ",
"    @@@    ",
"   @  @@   ",
"  @    @@  ",
" @      @@ ",
"@@@    @@@@",
"           ",
"           ",
"           "},
/* lines 15 */
/* 2359 */
{
"           ",
"@@@@   @@@@",
" @@     @  ",
"  @@   @   ",
"   @@ @    ",
"    @@     ",
"    @@     ",
"    @@     ",
"    @@     ",
"    @@     ",
"    @@     ",
"  @@@@@@   ",
"           ",
"           ",
"           "},
/* lines 15 */
/* 235a */
{
"           ",
" @@@@@@@@@ ",
" @     @@  ",
"@     @@   ",
"     @@    ",
"     @@    ",
"    @@     ",
"   @@      ",
"   @@      ",
"  @@      @",
" @@      @ ",
"@@@@@@@@@@ ",
"           ",
"           ",
"           "},
/* lines 15 */
/* 2361 */
{
"         ",
"         ",
"         ",
"         ",
"  @@@@   ",
" @@   @  ",
" @@   @@ ",
"   @@@@@ ",
" @@   @@ ",
"@@    @@ ",
"@@   @@@ ",
" @@@@  @@",
"         ",
"         ",
"         "},
/* lines 15 */
/* 2362 */
{
"         ",
"@@@      ",
" @@      ",
" @@      ",
" @@ @@   ",
" @@@  @@ ",
" @@    @@",
" @@    @@",
" @@    @@",
" @@    @@",
" @@@  @@ ",
"@@@ @@   ",
"         ",
"         ",
"         "},
/* lines 15 */
/* 2363 */
{
"        ",
"        ",
"        ",
"        ",
"   @@@  ",
" @@   @@",
"@@     @",
"@@      ",
"@@      ",
"@@     @",
" @@   @@",
"   @@@  ",
"        ",
"        ",
"        "},
/* lines 15 */
/* 2364 */
{
"         ",
"     @@@ ",
"      @@ ",
"      @@ ",
"   @@ @@ ",
" @@  @@@ ",
"@@    @@ ",
"@@    @@ ",
"@@    @@ ",
"@@    @@ ",
" @@  @@@ ",
"   @@ @@@",
"         ",
"         ",
"         "},
/* lines 15 */
/* 2365 */
{
"         ",
"         ",
"         ",
"         ",
"  @@@@@  ",
" @     @ ",
"@@     @@",
"@@@@@@@@@",
"@@       ",
"@@      @",
" @@    @@",
"   @@@@  ",
"         ",
"         ",
"         "},
/* lines 15 */
/* 2366 */
{
"        ",
"    @@@ ",
"   @  @@",
"  @@  @@",
"  @@    ",
"@@@@@@@@",
"  @@    ",
"  @@    ",
"  @@    ",
"  @@    ",
"  @@    ",
"@@@@@@  ",
"        ",
"        ",
"        "},
/* lines 15 */
/* 2367 */
{
"        ",
"        ",
"        ",
"        ",
"  @@@@@@",
" @@  @@ ",
" @   @@ ",
" @   @  ",
"  @@@   ",
" @@     ",
" @@@@@@ ",
"@@   @@@",
" @     @",
"  @@@@@ ",
"        "},
/* lines 15 */
/* 2368 */
{
"          ",
"@@@       ",
" @@       ",
" @@       ",
" @@ @@@   ",
" @@@  @@  ",
" @@    @@ ",
" @@    @@ ",
" @@    @@ ",
" @@    @@ ",
" @@    @@ ",
"@@@@  @@@@",
"          ",
"          ",
"          "},
/* lines 15 */
/* 2369 */
{
"      ",
"   @  ",
"  @@@ ",
"   @  ",
"      ",
"@@@@  ",
"  @@  ",
"  @@  ",
"  @@  ",
"  @@  ",
"  @@  ",
"@@@@@@",
"      ",
"      ",
"      "},
/* lines 15 */
/* 236a */
{
"      ",
"    @ ",
"   @@@",
"    @ ",
"      ",
" @@@@@",
"    @@",
"    @@",
"    @@",
"    @@",
"    @@",
"@@  @@",
"@@  @ ",
" @@@  ",
"      "},
/* lines 15 */
/* 236b */
{
"          ",
"@@@       ",
" @@       ",
" @@   @@@ ",
" @@   @   ",
" @@  @    ",
" @@ @@@   ",
" @@@ @@   ",
" @@   @@  ",
" @@   @@  ",
" @@    @@ ",
"@@@@   @@@",
"          ",
"          ",
"          "},
/* lines 15 */
/* 236c */
{
"      ",
"@@@@  ",
"  @@  ",
"  @@  ",
"  @@  ",
"  @@  ",
"  @@  ",
"  @@  ",
"  @@  ",
"  @@  ",
"  @@  ",
"@@@@@@",
"      ",
"      ",
"      "},
/* lines 15 */
/* 236d */
{
"            ",
"            ",
"            ",
"            ",
"@@@ @@ @@@  ",
" @@@ @@  @@ ",
" @@  @@  @@ ",
" @@  @@  @@ ",
" @@  @@  @@ ",
" @@  @@  @@ ",
" @@  @@  @@ ",
"@@@@ @@@ @@@",
"            ",
"            ",
"            "},
/* lines 15 */
/* 236e */
{
"          ",
"          ",
"          ",
"          ",
"@@@ @@@   ",
" @@@   @  ",
" @@    @@ ",
" @@    @@ ",
" @@    @@ ",
" @@    @@ ",
" @@    @@ ",
"@@@@  @@@@",
"          ",
"          ",
"          "},
/* lines 15 */
/* 236f */
{
"         ",
"         ",
"         ",
"         ",
"   @@@   ",
" @@   @@ ",
"@@     @@",
"@@     @@",
"@@     @@",
"@@     @@",
" @@   @@ ",
"   @@@   ",
"         ",
"         ",
"         "},
/* lines 15 */
/* 2370 */
{
"         ",
"         ",
"         ",
"         ",
"@@@ @@@  ",
" @@@  @@ ",
" @@    @@",
" @@    @@",
" @@    @@",
" @@    @@",
" @@@  @@ ",
" @@ @@@  ",
" @@      ",
"@@@@     ",
"         "},
/* lines 15 */
/* 2371 */
{
"         ",
"         ",
"         ",
"         ",
"  @@@ @@@",
" @@  @@@ ",
"@@    @@ ",
"@@    @@ ",
"@@    @@ ",
"@@    @@ ",
" @@  @@@ ",
"  @@@ @@ ",
"      @@ ",
"     @@@@",
"         "},
/* lines 15 */
/* 2372 */
{
"        ",
"        ",
"        ",
"        ",
"@@@ @@@ ",
" @@@  @@",
" @@   @@",
" @@     ",
" @@     ",
" @@     ",
" @@     ",
"@@@@    ",
"        ",
"        ",
"        "},
/* lines 15 */
/* 2373 */
{
"        ",
"        ",
"        ",
"        ",
" @@@@@@ ",
"@@    @ ",
"@@@     ",
" @@@@   ",
"   @@@@ ",
"@    @@@",
"@@    @@",
"@ @@@@@ ",
"        ",
"        ",
"        "},
/* lines 15 */
/* 2374 */
{
"        ",
"        ",
"   @    ",
"  @@    ",
"  @@    ",
"@@@@@@@@",
"  @@    ",
"  @@    ",
"  @@    ",
"  @@    ",
"  @@   @",
"   @@@@ ",
"        ",
"        ",
"        "},
/* lines 15 */
/* 2375 */
{
"          ",
"          ",
"          ",
"          ",
"@@@  @@@@ ",
" @@    @@ ",
" @@    @@ ",
" @@    @@ ",
" @@    @@ ",
" @@    @@ ",
" @@   @@@ ",
"  @@@@  @@",
"          ",
"          ",
"          "},
/* lines 15 */
/* 2376 */
{
"          ",
"          ",
"          ",
"          ",
"@@@@@  @@@",
" @@     @ ",
"  @@   @  ",
"  @@   @  ",
"   @@ @   ",
"   @@ @   ",
"    @@    ",
"    @@    ",
"          ",
"          ",
"          "},
/* lines 15 */
/* 2377 */
{
"           ",
"           ",
"           ",
"           ",
"@@@@ @@ @@@",
" @@  @@  @ ",
" @@  @@  @ ",
"  @@@ @@ @ ",
"  @@@ @@@  ",
"   @@  @@  ",
"   @@  @@  ",
"   @@  @@  ",
"           ",
"           ",
"           "},
/* lines 15 */
/* 2378 */
{
"         ",
"         ",
"         ",
"         ",
"@@@@  @@@",
" @@    @ ",
"  @@  @  ",
"   @@@   ",
"   @@@   ",
"  @  @@  ",
" @    @@ ",
"@@@  @@@@",
"         ",
"         ",
"         "},
/* lines 15 */
/* 2379 */
{
"         ",
"         ",
"         ",
"         ",
"@@@@@ @@@",
" @@    @ ",
"  @@   @ ",
"  @@  @  ",
"   @@ @  ",
"   @@@   ",
"    @@   ",
"@@  @    ",
"@@  @    ",
" @@@     ",
"         "},
/* lines 15 */
/* 237a */
{
"        ",
"        ",
"        ",
"        ",
"@@@@@@@@",
"@    @@ ",
"    @@  ",
"   @@   ",
"  @@    ",
" @@     ",
"@@     @",
"@@@@@@@@",
"        ",
"        ",
"        "}
};

static void avt_bannerhead   __P((const char *,
                                  const char *[][62],
                                  int
                                ));
static void avt_cartouche   __P((const char *,
                                 const char *,
                                 const char *,
                                 const char *,
                                 const char *,
                                 int
                               ));
extern void avt_banner      __P((const char *,
                                 const char *,
                                 const char *
                               ));
